;
; This source code can be used only in educational purposes.
;
; DK47 VxD-Emulator for DigiSHOW.vld is copyrighted by //UCL
;
; (c) Spot [UCL][UCF][rPG]
;
; E-Mail: sp0t@sp0t.loniis.spb.su
;
TITLE                   DESKey DK47 VxD-Emulator for DigiSHOW.vld

                        IDEAL
                        P486

                        MODEL   FLAT, STDCALL

STRUC                   ApiPacketStruc
Seed_1                  DW      ?
Seed_2                  DW      ?
Seed_3                  DW      ?
ByteCount               DW      ?
ReturnCode              DW      ?
Buffer                  DD      ?
ENDS                    ApiPacketStruc

DkEmu_Maj_Ver           EQU     01h
DkEmu_Min_Ver           EQU     00h
DkEmu_Req_Num           EQU     3630h

SEGMENT                 LCOD    DWORD PUBLIC 'LCODE' USE32
                                ASSUME cs:LCOD

                        PUBLIC  DK47WN95_DDB
DK47WN95_DDB            DD      0
DDK_Version             DW      400h
Req_Device_Number       DW      DkEmu_Req_Num
Dev_Maj_Ver             DB      DkEmu_Maj_Ver
Dev_Min_Ver             DB      DkEmu_Min_Ver
Flags                   DW      0
VxD_Name                DB      'DK47WN95'
Init_Order              DD      80000000h
Control_Proc            DD      OFFSET Control
V86_API_Proc            DD      0
PM_API_Proc             DD      0
V86_API_CSIP            DD      0
PM_API_CSIP             DD      0
Reference_Data          DD      0
Service_Table_Ptr       DD      0
Service_Size            DD      0
Win32_Service_Table     DD      0
DDB_Prev                DD      'Prev'
DDB_Size                DD      50h
DDB_Res1                DD      'Rsv1'
DDB_Res2                DD      'Rsv2'
DDB_Res3                DD      'Rsv3'

PROC                    Control
                        cmp     eax, 0000001Bh
                        jz      SysDynamicDeviceInit
                        cmp     eax, 0000001Ch
                        jz      SysDynamicDeviceExit
                        cmp     eax, 00000023h
                        jz      W32DeviceIoControl
                        xor     eax, eax
                        clc
                        ret
ENDP                    Control

PROC                    SysDynamicDeviceInit
                        xor     eax, eax
                        clc
                        ret
ENDP                    SysDynamicDeviceInit

PROC                    SysDynamicDeviceExit
                        xor     eax, eax
                        clc
                        ret
ENDP                    SysDynamicDeviceExit

PROC                    W32DeviceIoControl
                        mov     ecx, [esi + 0Ch] ; dwIoControlCode
                        cmp     ecx, 1
                        jz      @@FindDK47       ; FindDK47 ?
                        cmp     ecx, 2
                        jz      @@DK47ReadRandomNumbers ; DK47ReadRandomNumbers?
                        jmp     @@RetSuccess
@@FindDK47:
                        mov     ebx, [esi + 10h] ; lpInBuffer
                        mov     ax, 1
                        mov     [(ApiPacketStruc PTR ebx).ReturnCode], ax
                        jmp     @@RetSuccess
@@DK47ReadRandomNumbers:
                        mov     ebx, [esi + 10h]
                        movzx   ecx, [(ApiPacketStruc PTR ebx).ByteCount]
                        mov     edi, [(ApiPacketStruc PTR ebx).Buffer]
                        push    edi
                        xor     eax, eax
                        rep     stosb
                        pop     edi
                        add     edi, 447h
                        mov     ecx, 080h
                        mov     eax, 0FFFFFFFFh
                        rep     stosd
                        mov     [BYTE edi], 0CAh
@@RetSuccess:
                        xor     eax, eax
                        clc
                        ret
ENDP                    W32DeviceIoControl

ENDS                    LCOD
                        END
